<script setup>
import { ref, onMounted, onUnmounted } from "vue";
import { getTimeDiffString } from "@utils";
import PopUp from "@components/Template/PopUp.vue";
import SessionLauncher from "@components/Game/SessionLauncher.vue";

defineProps({
  levels: { type: Object, required: true },
  sessions: { type: Object, required: true },
});
const emit = defineEmits(["levelSelect", "sessionSelect", "sessionDelete"]);

const timestamp = ref(new Date());
let timer;

function setClock() {
  timestamp.value = new Date();
}
onMounted(() => (timer = setInterval(setClock, 1000)));
onUnmounted(() => clearInterval(timer));
</script>

<template>
  <table class="table has-background-transparent is-hoverable is-bordered is-fullwidth">
    <thead>
      <tr>
        <th>LEVEL</th>
        <th>SESSION</th>
        <th>ACTIVE STATE</th>
        <th>IN STATE</th>
        <th>REFERENCES</th>
        <th>CONTENT</th>
        <th>IN SESSION</th>
        <th class="has-no-outline"></th>
      </tr>
    </thead>
    <tbody>
      <template v-for="level in levels" :key="level._id">
        <tr v-if="!sessions || !sessions.hasOwnProperty(level._id)">
          <td>
            <button class="button p-0 is-ghost has-text-weight-semibold" @click="emit('levelSelect', level.name)">
              {{ level.name }}
            </button>
            <PopUp class="is-pulled-right">
              <template #anchor="{ togglePopup }">
                <button class="button has-no-outline has-background-transparent" @click="togglePopup">
                  <Icon :icon="'plus-circle'" />
                </button>
              </template>
              <template #content="{ togglePopup }">
                <div class="dropdown-item p-0">
                  <SessionLauncher :level-id="level._id" :level-name="level.name" @close="togglePopup" />
                </div>
              </template>
            </PopUp>
          </td>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
          <td></td>
        </tr>

        <tr v-for="(session, index) in sessions[level._id]" v-else :key="session" style="border: none">
          <th v-if="index == 0" :rowspan="sessions[level._id].length">
            <button class="button p-0 is-ghost has-text-weight-semibold" @click="emit('levelSelect', level.name)">
              {{ level.name }}
            </button>
            <PopUp class="is-pulled-right">
              <template #anchor="{ togglePopup }">
                <button class="button has-no-outline has-background-transparent" @click="togglePopup">
                  <Icon :icon="'plus-circle'" />
                </button>
              </template>
              <template #content="{ togglePopup }">
                <div class="dropdown-item p-0">
                  <SessionLauncher :level-id="level._id" :level-name="level.name" @close="togglePopup" />
                </div>
              </template>
            </PopUp>
          </th>
          <td>
            <button
              class="button is-ghost has-text-is-live has-text-weight-semibold"
              @click="emit('sessionSelect', level.name, session._id)"
            >
              {{ session.name }}
            </button>
          </td>
          <td>
            <div v-for="state in session.current_states" :key="state._id">
              <span>{{ state.name }}</span>
              <br />
            </div>
          </td>
          <td class="is-family-monospace">
            <div v-for="state in session.current_states" :key="state._id">
              <span>{{ getTimeDiffString(state.date, timestamp) }}</span>
              <br />
            </div>
          </td>
          <td class="content is-small">
            <details v-for="(value, key, i) in session.references" :key="session._id + key + i" class="mb-2">
              <summary class="is-clickable">
                <strong>{{ key }}</strong>
                <div v-for="(item, k) in value" :key="session._id + key + i + '_' + k">
                  <div class="pl-3 has-overflow-ellipsis">
                    Name:
                    <i>{{ item.name }}</i>
                  </div>
                  <div class="pl-3 has-overflow-ellipsis">
                    ID:
                    <i>{{ item._id }}</i>
                  </div>
                </div>
              </summary>
              {{ value }}
            </details>
          </td>
          <td class="content is-small">{{ session.content }}</td>
          <td class="is-family-monospace">
            {{ getTimeDiffString(session.created_at, timestamp) }}
          </td>
          <td class="pl-1 has-no-outline">
            <div class="is-flex">
              <Icon
                class="m-1 has-text-is-live"
                :icon="'external-link'"
                @click="emit('sessionSelect', level.name, session._id)"
              />

              <PopUp :unfold-right="true">
                <template #anchor="{ togglePopup }">
                  <Icon :icon="'trash-2'" @click="togglePopup" />
                </template>
                <template #content="{ togglePopup }">
                  <div class="dropdown-item p-1">
                    <div class="field is-grouped">
                      <p class="control">
                        <button class="button is-danger" @click="emit('sessionDelete', session)">Delete</button>
                      </p>
                      <p class="control">
                        <button class="button" @click="togglePopup">Cancel</button>
                      </p>
                    </div>
                  </div>
                </template>
              </PopUp>
            </div>
          </td>
        </tr>
      </template>
    </tbody>
  </table>
</template>
